function questionChange(){
	var quesTypeName=$("#quesTypeName").val();
	if(isOneChoice(quesTypeName)){
		$("#answer_td").text("选项及答案*");
		$("#Choose").show();
        $(".RadioContent").show();
        $(".CheckboxContent").hide();
        $("#answer-content").hide();
        $(".radioAdd").html("");
	}else if(isMultChoice(quesTypeName)){
		$("#answer_td").text("选项及答案*");
		$("#Choose").show();
        $(".CheckboxContent").show();
        $(".RadioContent").hide();
        $("#answer-content").hide();
        $(".checkboxAdd").html("");
	}else{
		$("#answer_td").text("答案*");
		$("#answer-content").show();
		$("#Choose").hide();
	}
}

function isOneChoice(quesTypeName){
	return (quesTypeName=="单项选择题" || quesTypeName=="单选题" || quesTypeName=="单选");
}

function isMultChoice(quesTypeName){
	return (quesTypeName=="多项选择题" || quesTypeName=="多选题" || quesTypeName=="多选");
}

function isChoice(quesTypeName){
	return isOneChoice(quesTypeName) || isMultChoice(quesTypeName);
}
 
function clean(){
	if (!$(".CheckboxContent").is(":hidden")) {
        $(".CheckboxContent").html("");
    }
    if (!$(".RadioContent").is(":hidden")) {
        $(".RadioContent").html("");
    }
}
function add(){
	if(($(".CheckboxContent .row").length=="26")&&(!$(".CheckboxContent").is(":hidden"))){
		alertify.error("无法继续添加选项!");
		return;
	}else if(($(".RadioContent .row").length=="26")&&(!$(".RadioContent").is(":hidden"))){
		alertify.error("无法继续添加选项!");
		return;
	}
	var Arr = ["A", "B", "C", "D", "E", "F", "G", "H", "I", "J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];
	if (!$(".CheckboxContent").is(":hidden")) {
		var v=Arr[$(".CheckboxContent .row").length];
		var id=v+"_"+"checkbox_input";
		var input=v+"_"+"checkbox_hidden";
        $(".CheckboxContent").append
        (" <div class=\"row\"><label class=\"col-lg-1 col-sm-1 checkbox-inline\"><input type=\"checkbox\"  name=\"optionsCKs\" value="+v+"  class=\"validate[required] checkbox\" />" 
        		+ v + ".</label><a  onclick=\"del(this)\" href=\"javascript:void(0)\">删除</a><div class=\"col-lg-5 col-sm-5\"><input class=\"validate[required] text-input  listInput\" id="
        		+id+"   style=\"width: 350px;\" readonly=\"readonly\" /></div><div id="+v+"_checkbox_div class=\"list\" field=\"answer\" name=\"答案\" title=\"点击输入内容\"><input type=\"hidden\" id="+input+" /></div></div>");
    }
    if (!$(".RadioContent").is(":hidden")) {
    	var v=Arr[$(".RadioContent .row").length];
    	var id=v+"_"+"radio_input";
    	var input=v+"_"+"radio_hidden";
        $(".RadioContent").append
        (" <div class=\"row\"><label class=\"col-lg-1 col-sm-1\"><input class=\"validate[required] radio \" type=\"radio\" name=\"optionsRadios\"   value="+v+" />" 
        		+v + ".</label><a  onclick=\"del(this)\" href=\"javascript:void(0)\">删除</a> <div class=\"col-lg-5 col-sm-5\"><input class=\"validate[required] text-input listInput\" id="
        		+id+"   style=\"width: 350px;\" readonly=\"readonly\" /></div><div id="+v+"_radio_div class=\"list\" field=\"answer\" name=\"答案\" title=\"点击输入内容\"><input type=\"hidden\" id="+input+" /></div></div>");
    }
}
function del($this){
	$this=$($this);
	var str=$this.parent().find("input").val();
	var num=str.charCodeAt()-65;
	$this.parent().remove();
	var Arr = ["A", "B", "C", "D", "E", "F", "G", "H", "I", "J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];
	if (!$(".CheckboxContent").is(":hidden")) {
		$(".CheckboxContent .row").each(function(i){
			if(i>=num){
				var v=Arr[i];
				var text_value=$("#"+Arr[i+1]+"_checkbox_hidden").val();
				 var input_value=$("#"+Arr[i+1]+"_checkbox_input").val();
				var id=v+"_"+"checkbox_input";
				var input=v+"_"+"checkbox_hidden";
				if(input_value==""){
					$(this).html("<label class=\"col-lg-1 col-sm-1 checkbox-inline\"><input type=\"checkbox\"  name=\"optionsCKs\" value="+v+"  class=\"validate[required] checkbox\" />" 
			        		+ v + ".</label><a  onclick=\"del(this)\" href=\"javascript:void(0)\">删除</a><div class=\"col-lg-5 col-sm-5\"><input class=\"validate[required] text-input  listInput\" id="
			        		+id+"   style=\"width: 350px;\" readonly=\"readonly\"  value=''   /></div><div id="+v+"_checkbox_div class=\"list\" field=\"answer\" name=\"答案\" title=\"点击输入内容\"><input type=\"hidden\" id="+input+" /></div>");
				}else{
					$(this).html("<label class=\"col-lg-1 col-sm-1 checkbox-inline\"><input type=\"checkbox\"  name=\"optionsCKs\" value="+v+"  class=\"validate[required] checkbox\" />" 
			        		+ v + ".</label><a  onclick=\"del(this)\" href=\"javascript:void(0)\">删除</a><div class=\"col-lg-5 col-sm-5\"><input class=\"validate[required] text-input  listInput\" id="
			        		+id+"   style=\"width: 350px;\" readonly=\"readonly\"  value="+input_value+"   /></div><div id="+v+"_checkbox_div class=\"list\" field=\"answer\" name=\"答案\" title=\"点击输入内容\"><input type=\"hidden\" id="+input+" /></div>");
				}
				$("#"+input).val(text_value);
			}
		});
	}
	if (!$(".RadioContent").is(":hidden")) {
		 $(".RadioContent .row").each(function(i){
			 if(i>=num){
				 var v=Arr[i];
				 var text_value=$("#"+Arr[i+1]+"_radio_hidden").val();
				 var input_value=$("#"+Arr[i+1]+"_radio_input").val();
				 var id=v+"_"+"radio_input";
				 var input=v+"_"+"radio_hidden";
				 if(input_value==""){
					 $(this).html("<label class=\"col-lg-1 col-sm-1\"><input class=\"validate[required] radio \" type=\"radio\" name=\"optionsRadios\"   value="+v+" />" 
				        		+v + ".</label><a  onclick=\"del(this)\" href=\"javascript:void(0)\">删除</a> <div class=\"col-lg-5 col-sm-5\"><input class=\"validate[required] text-input listInput\" id="
				        		+id+"   style=\"width: 350px;\" readonly=\"readonly\"  value=''        /></div><div id="+v+"_radio_div class=\"list\" field=\"answer\" name=\"答案\" title=\"点击输入内容\"><input type=\"hidden\" id="+input+"   /></div>");
				 }else{
					 $(this).html("<label class=\"col-lg-1 col-sm-1\"><input class=\"validate[required] radio \" type=\"radio\" name=\"optionsRadios\"   value="+v+" />" 
				        		+v + ".</label><a  onclick=\"del(this)\" href=\"javascript:void(0)\">删除</a> <div class=\"col-lg-5 col-sm-5\"><input class=\"validate[required] text-input listInput\" id="
				        		+id+"   style=\"width: 350px;\" readonly=\"readonly\"  value=" +input_value+ "        /></div><div id="+v+"_radio_div class=\"list\" field=\"answer\" name=\"答案\" title=\"点击输入内容\"><input type=\"hidden\" id="+input+"   /></div>");
				 }
				 $("#"+input).val(text_value);
			 }
		});
	 }
}

function getRadioIds(){
	debugger;
	var length=$("input[name=optionsRadios]").length.toString();		//radio的个数
	if(length != 4){
		alertify.error("单项选择题选项应该为4个!");
		return "false";
	}
	var str=$("input[name=optionsRadios]:checked").val();				//被选中的按钮
	if(!str){
		alertify.error("请设置一个选项为答案!");
		return "false";
	}
	var all_option_isnum = true;//数字类型
	var regex = new RegExp("^(-)?[0-9]\\d*\\.{0,1}\\d*|0\\.{0,1}\\d*[0-9]\\d*$");//判断是否数字类型
	var code=str.charCodeAt(0);											//被选中按钮转ascii
	var correctOption=code-65;											//被选中的-65转成与数据库对应的数据
	var arr = new Array();
	var arr1=new Array();
	var val_arr = new Array();
	for(var i=0;i<length;i++){
		var isCorrectOption=0;
		if(i==correctOption){
			isCorrectOption=1;
		}
		var str=(String.fromCharCode(i+65));
		arr1.push($("#"+str+"_radio_input").html());
		var obj = {
			"id" :  $("#"+str+"_radio_id").val(),
			"optionNo" : i,
			"isCorrectOption" : isCorrectOption,
			"content" : $("#"+str+"_radio_input").html(),
			"summary" :$("#"+str+"_radio_input").text()
		};
		//是否使用“以上都不对、以上都对、从未、绝无、也许、可能、唯一、只有、仅仅”等含有绝对肯定、绝对否定或模棱两可的词汇；
		if (obj.content && (obj.content.indexOf("以上都不对") != -1
				|| obj.content.indexOf("以上都对") != -1 || obj.content.indexOf("从未") != -1
				|| obj.content.indexOf("绝无") != -1 || obj.content.indexOf("也许") != -1
				|| obj.content.indexOf("可能") != -1 || obj.content.indexOf("唯一") != -1
				|| obj.content.indexOf("只有") != -1 || obj.content.indexOf("仅仅") != -1)) {
			alertify.error("选项内容不能出现[以上都不对、以上都对、从未、绝无、也许、可能、唯一、只有、仅仅]'!");
			return "false";
		}
		arr.push(JSON.stringify(obj));
		val_arr.push(obj.content);
		debugger;
		if (!regex.test(obj.content)) {
			all_option_isnum = false;
		}
	}
	//所有选项都是数字
	if (all_option_isnum) {
		if (val_arr.length == 4) {
			if ((val_arr[0] < val_arr[1] && val_arr[1] < val_arr[2] && val_arr[2] < val_arr[3])
					|| (val_arr[0] > val_arr[1] && val_arr[1] > val_arr[2] && val_arr[2] > val_arr[3])) {
				
			} else {
				alertify.error("数值类型选项要么升序要么降序!");
				return "false";
			}
		} else if (val_arr.length == 5) {
			if ((val_arr[0] < val_arr[1] && val_arr[1] < val_arr[2] && val_arr[2] < val_arr[3] && val_arr[3] < val_arr[4])
					|| (val_arr[0] > val_arr[1] && val_arr[1] > val_arr[2] && val_arr[2] > val_arr[3] && val_arr[3] > val_arr[4])) {
				
			} else {
				alertify.error("数值类型选项要么升序要么降序!");
				return "false";
			}
		}
	}
	//debugger;
	var nary=arr1.sort();
	for(var i=0;i<arr1.length;i++){
		if(nary[i] == '' || nary[i] == '<br>'){
			alertify.error("选项不能为空，请输入!");
			return "false";
		}
		if(nary[i]==nary[i+1]){
			alertify.error("选项不能重复，请重新修改!");
			return "false";
		}
	}

	return arr;
}

function getCheckBoxIds(){
	debugger;
	var length=$("input[name=optionsCKs]").length.toString();
	if(length != 5){
		alertify.error("多项选择题选项应该为5个!");
		return "false";
	}
	var strarr = new Array();
	 $("input[name=optionsCKs]:checked").each(function(){
		strarr.push( $(this).val());
	});
	if(strarr.length == 0){
		alertify.error("请至少设置一个选项为答案!");
		return "false";
	}
	var correctArr=new Array();
	var arr1=new Array();
	for(var i=0;i<strarr.length;i++){
		var code=strarr[i].charCodeAt(0);
		var correctOption=code-65;
		correctArr.push(correctOption);
	}
	var arr = new Array();
	var val_arr = new Array();
	var all_option_isnum = true;//数字类型
	var regex = new RegExp("^(-)?[0-9]\\d*\\.{0,1}\\d*|0\\.{0,1}\\d*[0-9]\\d*$");//判断是否数字类型
	for(var i=0;i<length;i++){
		var isCorrectOption=0;
		if($.inArray(i, correctArr)!=-1){
			isCorrectOption=1;
		}
		var str=(String.fromCharCode(i+65));
		arr1.push($("#"+str+"_checkbox_input").html());
		var obj = {
				"id" : $("#"+str+"_checkbox_id").val(),
				"optionNo" : i,
				"isCorrectOption" : isCorrectOption,
				"content" : $("#"+str+"_checkbox_input").html(),
				"summary" :	$("#"+str+"_checkbox_input").text()
		};
		//是否使用“以上都不对、以上都对、从未、绝无、也许、可能、唯一、只有、仅仅”等含有绝对肯定、绝对否定或模棱两可的词汇；
		if (obj.content && (obj.content.indexOf("以上都不对") != -1
				|| obj.content.indexOf("以上都对") != -1 || obj.content.indexOf("从未") != -1
				|| obj.content.indexOf("绝无") != -1 || obj.content.indexOf("也许") != -1
				|| obj.content.indexOf("可能") != -1 || obj.content.indexOf("唯一") != -1
				|| obj.content.indexOf("只有") != -1 || obj.content.indexOf("仅仅") != -1)) {
			alertify.error("选项内容不能出现[以上都不对、以上都对、从未、绝无、也许、可能、唯一、只有、仅仅]'!");
			return "false";
		}
		arr.push(JSON.stringify(obj));
		val_arr.push(obj.content);
		debugger;
		if (!regex.test(obj.content)) {
			all_option_isnum = false;
		}
	}
	//所有选项都是数字
	if (all_option_isnum) {
		if (val_arr.length == 4) {
			if ((val_arr[0] < val_arr[1] && val_arr[1] < val_arr[2] && val_arr[2] < val_arr[3])
					|| (val_arr[0] > val_arr[1] && val_arr[1] > val_arr[2] && val_arr[2] > val_arr[3])) {
				
			} else {
				alertify.error("数值类型选项要么升序要么降序!");
				return "false";
			}
		} else if (val_arr.length == 5) {
			if ((val_arr[0] < val_arr[1] && val_arr[1] < val_arr[2] && val_arr[2] < val_arr[3] && val_arr[3] < val_arr[4])
					|| (val_arr[0] > val_arr[1] && val_arr[1] > val_arr[2] && val_arr[2] > val_arr[3] && val_arr[3] > val_arr[4])) {
				
			} else {
				alertify.error("数值类型选项要么升序要么降序!");
				return "false";
			}
		}
	}
	var nary=arr1.sort();
	for(var i=0;i<arr1.length;i++){
		if(nary[i] == '' || nary[i] == '<br>'){
			alertify.error("选项不能为空，请输入!");
			return "false";
		}
		if(nary[i]==nary[i+1]){
			alertify.error("选项不能重复，请重新修改!");
			return "false";
		}
	}
	return arr;
}
//题干相似度检查
function goSimilaryCheck() {
	
}

function validationBodyAnswer(){
	if($("#body-content").text()==""){
		alertify.error("题干不能为空，请输入!");
		$("#body-content").focus();
		return false;
	}
	var typeName=$("#quesTypeName").val();
	if(!isChoice(typeName)){
		if ($("#answer-content").text()==""){
			alertify.error("答案不能为空!");
			return false;
		}else{
			return true;
		}
	}else{
		return true;
	}
	
}

function validateBaseInfo(){
	var chapter=$("#chapter").val();
	if(chapter == ''){
		alertify.error("知识点--章不能为空，请输入!");
		$("#chapter").focus();
		return false;
	}
	chapter = parseInt(chapter) - 0;
	if(!chapter || chapter <= 0){
		alertify.error("知识点--章必须为正整数，请重新输入!");
		$("#chapter").select();
		$("#chapter").focus();
		return false;
	}
	if(chapter > ($("#chapterSize").val() - 0)){
		alertify.error("知识点--章不能超过教材设置的总章数（" + $("#chapterSize").val() + "），请重新输入!");
		$("#chapter").select();
		$("#chapter").focus();
		return false;
	}
	return true;
}

function goSave(url){
	var isValid =  validateBaseInfo();
	if(isValid){
		if(validationBodyAnswer()){
			var id = $("#quesId").val();
			var questionNo=$("#questionNo").val();													//题号
			var courseId=$("#courseId").val();														//课程id
			var typeId=$("#quesTypeId").val();														//题型id
			var typeName=$("#quesTypeName").val();
			var bookId=$("#bookId").val();															//教材id
			var assessmentDemand=$('input[name="assessmentDemand"]:checked').val();
			var estimateDifficultyCode=$('input[name="estimateDifficultyCode"]:checked').val();		//预计难度
			var gradeCode=$('input[name="gradeCode"]:checked').val();								//层次
			var abilityCode=$('input[name="abilityCode"]:checked').val();							//能力要求
			var chapter=$("#chapter").val();														//章
			var section=$("#section").val();														//节
			var item=$("#item").val();															//目
			var page=$("#page").val();																//页
			var score=$("#score").val();															//满分值
			var body=$("#body-content").html();														//题干
			var bodySummary=$("#body-content").text();
			var answer="";
			var answerSummary="";
			var arr = new Array();
			if(!isChoice(typeName)){
				answer=$("#answer-content").html();													//答案
				answerSummary=$("#answer-content").text();
			}else{
				if(isOneChoice(typeName)){
					arr=getRadioIds();
					if(arr=="false"){
						return;
					}
				}else{
					arr=getCheckBoxIds();
					if(arr=="false"){
						return;
					}
				}
			}
			var remark=$("#remark").val();																	//备注
			var obj = {
					"id"	:	id,
					"questionNo":questionNo,																//题号
					"assessmentDemand":assessmentDemand,													//考核要求
					"courseId" : courseId,																	//课程id
					"typeId": typeId,																		//题型id
					"bookId" : bookId,																		//教材id
					"estimateDifficultyCode" : estimateDifficultyCode,										//预计难度
					"gradeCode" : gradeCode,																//层次
					"abilityCode" : abilityCode,															//能力要求
					"chapter" : chapter,																	//章
					"section" : section,																	//节
					"item" : item,																			//目
					"page" : page,																			//页
					"score" :  score,																		//满分值
					"body" : body,																			//题干
					"bodySummary" :bodySummary,
					"answer" : answer,																		//答案
					"answerSummary" : answerSummary,
					"remark" : remark																		//备注
				};
			var Question = JSON.stringify(obj);
			$(document).mask('正在保存试题，请稍等...');
			$.ajax({
				type : "POST",
				url : url + "/question/zujuanSave?paperId=" + $("#paperId").val() + "&quesTypeId=" + $("#quesTypeId").val() + "&paperDetailId=" + $("#detailId").val(),
				data : "{Question:" + Question + ",arr:" + "[" + arr + "]" + "}", 
				contentType : "application/json; charset=utf-8",
				dataType : "json",
				success : function(callback) {
					$(document).unmask();
					callback = eval(callback);
					if(callback.flag=='failed'){
						alertify.error(callback.msg);
					}else{
						if(saveType == 'ADD'){
							$('#body-content').html('');
							$('#A_radio_input').html('');
							$('#B_radio_input').html('');
							$('#C_radio_input').html('');
							$('#D_radio_input').html('');
							
							$('#A_checkbox_input').html('');
							$('#B_checkbox_input').html('');
							$('#C_checkbox_input').html('');
							$('#D_checkbox_input').html('');
							$('#E_checkbox_input').html('');
							
							$("input:radio[name='optionsRadios']:checked").removeAttr("checked");						
							$("input:checkbox[name='optionsCKs']:checked").removeAttr("checked");
							
							$('#answer-content').html('');
							$('#answerSheet').html('');
							$('#remark').val('');
							$('#infoTable tr:gt(0)').remove();
							//$.messager.alert('提示', "新增试题成功!", 'info');
							
							if(parent.manualAddQues($("#pqtId").val(),callback.question)){    //传入question对象
								$("#blankQuesNum").val($("#blankQuesNum").val()-1);
								$("#blankQuesNumFowShow").text($("#blankQuesNum").val());
								autoReduce();
								if($("#blankQuesNum").val() - 0 == 0){
									alertify.success("新增试题成功，当前题型已经完成命题。");
									parent.closeAddQuestionDiv();
								}else{
									alertify.success("新增试题成功，可继续命题。");
									getNewQuestionNoByCourseId();
								}
							}else{
								parent.closeAddQuestionDiv();
							}
						}else{
							parent.updateQues($("#detailId").val(),callback.question);
							parent.closeEditQuestionDiv();
						}
					}
				}
			});
		}
	}
}